from urllib2 import urlopen
from Components.MenuList import MenuList
from Components.Label import Label

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap
from Components.Input import Input
from Components.Pixmap import Pixmap
from Components.FileList import FileList
from Components.Button import Button
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap
from Screens.InputBox import InputBox

from enigma import eServiceReference
from enigma import eServiceCenter

from twisted.web.client import getPage, downloadPage
# Config
from Components.config import config, ConfigEnableDisable, ConfigSubsection, \
			 ConfigYesNo, ConfigClock, getConfigListEntry, \
			 ConfigSelection, ConfigNumber
from Components.ConfigList import ConfigListScreen

from Screens.InfoBar import MoviePlayer
from Components.ServiceEventTracker import ServiceEventTracker, InfoBarBase
from Screens.InfoBarGenerics import InfoBarShowHide, InfoBarSeek, InfoBarNotifications, InfoBarServiceNotifications

#####################################################################
#                                                                   #
#   MySpaceDirect : Coded by pcd@i-have-a-dreambox, October 2010    #
#                                                                   #
#####################################################################
#Set default configuration
config.plugins.myspace = ConfigSubsection()
config.plugins.myspace.category = ConfigSelection(default = "34", choices = [
		("34", _("Music videos")),
		("22", _("Entertainment")),
                ("44", _("Sports")),
                ("47", _("Travel")),
		("42", _("Science")),
		("13", _("Animation")),
                ("11", _("Animals")) 
		])
config.plugins.myspace.showfor = ConfigSelection(default = "3", choices = [
		("1", _("Today")),
		("2", _("This week")),
		("3", _("This month")),
                ("4", _("All time")) 
		])
		
config.plugins.myspace.country = ConfigSelection(default = "GB", choices = [
		("GB", _("UK")),
		("DE", _("Germany")),
		("FR", _("France")),
		("ES", _("Spain")),
		("IN", _("India")),
                ("SE", _("Sweden")),
		("US", _("USA"))
		])		

config.plugins.myspace.language = ConfigSelection(default = "en", choices = [
		("en", _("English")),
		("de", _("German")),
		("fr", _("French")),
		("es", _("Spanish")),
		("hi", _("Hindi")),
                ("sv", _("Swedish"))
		])
##################################
# Configuration GUI

class Config(ConfigListScreen,Screen):
	skin = """
<screen position="center,center" size="560,400" title="Plugin MySpaceDirect" >
	<ePixmap name="red"    position="0,0"   zPosition="2" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />
	<ePixmap name="green"  position="140,0" zPosition="2" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />
	<ePixmap name="yellow" position="280,0" zPosition="2" size="140,40" pixmap="skin_default/buttons/yellow.png" transparent="1" alphatest="on" /> 
	<ePixmap name="blue"   position="420,0" zPosition="2" size="140,40" pixmap="skin_default/buttons/blue.png" transparent="1" alphatest="on" /> 

	<widget name="key_red" position="0,0" size="140,40" valign="center" halign="center" zPosition="4"  foregroundColor="white" font="Regular;20" transparent="1" shadowColor="background" shadowOffset="-2,-2" /> 
	<widget name="key_green" position="140,0" size="140,40" valign="center" halign="center" zPosition="4"  foregroundColor="white" font="Regular;20" transparent="1" shadowColor="background" shadowOffset="-2,-2" /> 
	<widget name="key_yellow" position="280,0" size="140,40" valign="center" halign="center" zPosition="4"  foregroundColor="white" font="Regular;20" transparent="1" shadowColor="background" shadowOffset="-2,-2" />
	<widget name="key_blue" position="420,0" size="140,40" valign="center" halign="center" zPosition="4"  foregroundColor="white" font="Regular;20" transparent="1" shadowColor="background" shadowOffset="-2,-2" />

	<widget name="config" position="10,40" size="540,240" scrollbarMode="showOnDemand" />

	<ePixmap alphatest="on" pixmap="skin_default/icons/clock.png" position="480,383" size="14,14" zPosition="3"/>
	<widget font="Regular;18" halign="left" position="505,380" render="Label" size="55,20" source="global.CurrentTime" transparent="1" valign="center" zPosition="3">
		<convert type="ClockToText">Default</convert>
	</widget>
	<widget name="statusbar" position="10,380" size="470,20" font="Regular;18" />
	<widget name="status" position="10,300" size="540,60" font="Regular;20" />
</screen>"""
		
	def __init__(self, session, args = 0):
		self.session = session
		self.setup_title = _("Plugin MySpaceDirect")
		Screen.__init__(self, session)
		cfg = config.plugins.myspace
                self.list = [
			getConfigListEntry(_("Video category"), cfg.category),
			getConfigListEntry(_("Period"), cfg.showfor),
			getConfigListEntry(_("Country"), cfg.country),
			getConfigListEntry(_("Language"), cfg.language),
			]
		ConfigListScreen.__init__(self, self.list, session = self.session, on_change = self.changedEntry)
		self["status"] = Label()
		self["statusbar"] = Label()
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button(_("Save"))
		self["key_blue"] = Button(_("Videos"))
		self["key_yellow"] = Button(_("Search"))

		self["setupActions"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"red": self.cancel,
			"green": self.save,
			"blue": self.getlist,
			"yellow": self.search,			
			"save": self.save,
			"cancel": self.cancel,
			"ok": self.save,
		}, -2)
#                self.lastImportResult = None
		self.onChangedEntry = []

	
	# for summary:
	def changedEntry(self):
		for x in self.onChangedEntry:
			x()
	def getCurrentEntry(self):
		return self["config"].getCurrent()[0]
	def getCurrentValue(self):
		return str(self["config"].getCurrent()[1].getText())
	def createSummary(self):
		from Screens.Setup import SetupSummary
		return SetupSummary

	def save(self):
		#print "saving"
		self.saveAll()
		self.close(True,self.session)

	def cancel(self):
		#print "cancel"
#		self.updateTimer.stop()
		for x in self["config"].list:
			x[1].cancel()
		self.close(False,self.session)
		
        def getlist(self):
                cat = config.plugins.myspace.category.value
                period = config.plugins.myspace.showfor.value
                country = config.plugins.myspace.country.value
                lang = config.plugins.myspace.language.value
                self.session.open(Geturl, cat, period, country, lang)

        def search(self):
                self.session.openWithCallback(self.makeurl, InputBox, title=_("Please enter search words"), maxSize=False, visible_width = 56, type=Input.TEXT)


        def makeurl(self, cline):
            print "cline =", cline 
            if cline is not None:
                cline = cline.replace ( ' ', '+' )
                url = "http://searchservice.myspace.com/index.cfm?fuseaction=sitesearch.results&type=MySpaceTV&qry=" + cline + "&videotype=1"
                self.session.open(Searchurl, url) 




##################################################
class Searchurl(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Video list" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, url):
		self.skin = Searchurl.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                print "self.url =", self.url
                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
           self["info"].setText("Downloading list...")
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           start = 0
           print "fpage =", fpage
           self.entry = []
           self.url1 = []
     
	   i = 0
	   icount = 0
	   while i<50 :
                pos1 = fpage.find("vcard", start)
                if (pos1 <0 ):
                      break          
                pos3 = fpage.find("thumb1", pos1+4)
                if (pos3 <0 ):
                      start = pos1
                      i = i+1
                      continue    
                str1 = fpage[(pos3-20):pos3]
                svid = str1.find("videos02")
                if svid <0:
                      start = pos3
                      i = i+1
                      continue
                pos2 = fpage.find('videos02', pos1+4)
                pos4 = fpage.find('.jpg', pos3+4)
                if pos4 <0:
                      start = pos3
                      i = i+1
                      continue
                pos5 = fpage.find('a class', pos4+4)
                if pos5 <0:
                      start = pos4
                      i = i+1
                      continue
                pos6 = fpage.find('">', pos5+4)       
                if pos6 <0:
                      start = pos5
                      i = i+1
                      continue
                pos7 = fpage.find('</a>', pos6+2)       
                if pos7 <0:
                      start = pos6
                      i = i+1
                      continue 
                name = fpage[(pos6+2):pos7]      
                name = name.replace("<mark>", " ")      
                name = name.replace("</mark>", " ")
                id1 =  fpage[(pos2+9):(pos3-1)]
                id2 =  fpage[(pos3+7):(pos4)]
                    
                self.entry.append(name)
                vurl = "http://l3-hl1.videos02.myspacecdn.com/videos02/" + id1 + "/" + id2 + "/vid.mp4"
                print "i name vurl =", i, name, vurl
                self.url1.append(vurl)
                   
                i = i+1
                start = pos7 + 1;
           self.icount = 1
           self["info"].setText("")
           self["list"].setList(self.entry)

    def okClicked(self):
	        ientry = self["list"].getSelectionIndex()
                url = self.url1[ientry]
                name = self.entry[ientry]
                sref = eServiceReference(4097,0,url)
                sref.setName(name)
                self.session.open(Playvid, sref)

    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)		

class Geturl(Screen):

    skin = """
		<screen position="center,center" size="550,400" title="Video list" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, cate, peri, coun, lang):
		self.skin = Geturl.skin
		Screen.__init__(self, session)
		
		self.cate = cate
		self.peri = peri
		self.coun = coun
		self.lang = lang

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.icount = 0
                self.entry = []
                self.url1 = []
                self.onLayoutFinish.append(self.openTest)          

    def openTest(self):
          ipage = 0
          while ipage<3 :      
                self["info"].setText("Downloading list...")
                url = "http://vids.myspace.com/index.cfm?fuseaction=vids.charts&category=" + self.cate + "&show_for=" + self.peri + "&country=" + self.coun + "&language=" + self.lang + "&page=" + str(ipage);
                print "url =", url
                getPage(url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)
                ipage = ipage+1

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           iurl = []
           iname = []
           surl = []
           self.names = []
           self.urls = []
           start = 0

           str1 = " "
	   i = 0
	   icount = 0
	   while i<50 :
                    pos1 = fpage.find('div class="ventry', start)
                    if (pos1 < 0):
                           i = i+1
                           break
 		    pos2 = fpage.find("title=", pos1+4)
 		    if (pos2 < 0):
                           start = pos1 + 5
                           i = i+1
                           continue
                    pos3 = fpage.find('"', pos2+8)
                    if (pos3 < 0):
                           start = pos2 + 2
                           i = i+1
                           continue                    
                    pos5 = fpage.find('thumb1', pos3+1)
                    if (pos5 < 0):
                           start = pos3 + 2
                           i = i+1
                           continue 
                    str1 = fpage[(pos5-20):pos5]
                    svid = str1.find("videos02")
                    if (svid < 0):
                           start = pos5 + 2
                           i = i+1
                           continue

                    pos4 = fpage.find('videos02', pos3+1)
                    if (pos4 < 0):
                           start = pos5 + 2
                           i = i+1
                           continue                            
                    pos6 = fpage.find('jpg', pos5+7)
                    if (pos6 < 0):
                           start = pos5 + 2
                           i = i+1
                           continue        
		
                    name = fpage[(pos2+11):(pos3-5)]
                    id1 =  fpage[(pos4+9):(pos5-1)]
                    id2 =  fpage[(pos5+7):(pos6-1)]
                    
                    self.entry.append(name)
                    vurl = "http://l3-hl1.videos02.myspacecdn.com/videos02/" + id1 + "/" + id2 + "/vid.mp4"
                    self.url1.append(vurl)
#                    print "name vurl =", name, vurl 
                    i = i+1
                    start = pos6 + 1;
           self.icount = 1
           self["info"].setText("")
           self["list"].setList(self.entry)

    def okClicked(self):
	        ientry = self["list"].getSelectionIndex()
                url = self.url1[ientry]
                name = self.entry[ientry]
                sref = eServiceReference(4097,0,url)
                sref.setName(name)
                self.session.open(Playvid, sref)

    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)		

class Playvid(Screen,InfoBarNotifications):

    def __init__(self, session, service):
                Screen.__init__(self, session)
                self.skinName = "MoviePlayer"
                InfoBarNotifications.__init__(self)
                self.session = session
		self.service = service
        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = NumberActionMap(["WizardActions", "InputActions","InfobarSeekActions", "MediaPlayerActions"],
		{
			"ok": self.ok,
			"back": self.close,
			"left": self.keyLeft,
			"right": self.keyRight,
		}, -1)

                self.onLayoutFinish.append(self.prepare)
                
    def prepare(self):
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.session.nav.stopService()
                self.play()                
                
    def play(self):            
                self.session.nav.playService(self.service)
    
    def close(self):
                self.session.nav.stopService()
                self.session.nav.playService(self.srefOld)
                Screen.close(self)

    def keyLeft(self):
		pass
	
    def keyRight(self):
		pass
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)

    def showInfobar(self):
		self.show()

    def hideInfobar(self):
		self.hide()

    def ok(self):
		if self.shown:
			self.hideInfobar()
		else:
			self.showInfobar()
     

def main(session, **kwargs):
        session.open(Config)
        
		

def Plugins(**kwargs):
	return PluginDescriptor(name="MySpaceDirect", description="Streams videos from MySpace", where = [ PluginDescriptor.WHERE_EXTENSIONSMENU, PluginDescriptor.WHERE_PLUGINMENU ], fnc=main)



